class golem: 
	def __init__(self):
		self.state = "Search"
		self.PointsOfInterest = []
		self.PointsOfInterest.append(engine.Vector2(11.2, 10.8))
		#TC._instance.GoToPosition(engine.Vector2(10,0))
		self.EverythingIHaveSeen = []
		self.GatheredItems = []
		self.FoundGarbage = []
		self.FoundDropOffs = []
		self.FocusItem = None
		
	def Frame(self):
		#log("State= "+ self.state + "\nFocusItem= " + str(self.FocusItem))
		
		self.LookAroundMe()
		
		if self.state == "Search":
			self.ModeSearch()
		elif self.state == "PickUpItem":
			self.ModePickUpItem()
		elif self.state == "ReturnWithItem":
			self.ModeReturnWithItem()
		else:
			pass		
	
	def LookAroundMe(self):
		nearbyItems = TC._instance.LookAround()		
		for x in nearbyItems:
			if x not in self.EverythingIHaveSeen:
				log("That looks new, what is it?")
				self.EverythingIHaveSeen.append(x)
				#Determine what the thing is, and what to do about it.
				if x.description.Contains("shiny") and x.description.Contains("item"):
					if x not in self.FoundGarbage:
						log("It's some garbage! Ill come back for it!")
						self.FoundGarbage.append(x)
				elif x.description.Contains("pink") and x.description.Contains("deposit"):
					if x not in self.FoundDropOffs:
						log("A garbage can, I can put trash there")
						self.FoundDropOffs.append(x)
				
		
			
				
				
	# Search (look around), PickUpItem, Return with Item, 
	
	def ModeSearch(self):	
		if self.FocusItem == None:
			for	y in self.FoundGarbage:
				if y not in self.GatheredItems:						
					self.state = "PickUpItem"
					self.FocusItem = y
						
	
	def ModePickUpItem(self):	
		TC._instance.GoToItem(self.FocusItem)			
		distance = engine.Vector3.Distance(TC._instance.transform.position, self.FocusItem.transform.position)		
		if TC._instance.handsFull == True:
			self.FocusItem = TC._instance.heldItem
			self.state = "ReturnWithItem"
		elif distance < 1:
			TC._instance.PickUp(self.FocusItem)
	
	def ModeReturnWithItem(self):
		TC._instance.GoToItem(self.FindClosestDropOff())	
		distance = engine.Vector3.Distance(TC._instance.transform.position, self.FindClosestDropOff().transform.position)
		if distance < 2:
			TC._instance.PutDown()
			self.FindClosestDropOff().DepositItem(self.FocusItem)
			self.GatheredItems.append(self.FocusItem)
			self.FocusItem = None
			self.state = "Search"		
			
	def FindClosestDropOff(self):
		lowestDistance = 99999
		winner = None
		for SF in self.FoundDropOffs:
			distance = engine.Vector3.Distance(TC._instance.transform.position, SF.transform.position)
			if distance < lowestDistance:
				winner = SF
				lowestDistance = distance
		return winner