# Emily, this is a script that will have the golem determine what is rotten and try to throw it away 
# If there is no garbage can near the golem when it starts, it breaks though. Curious.
class golem: 
	def __init__(self, golem):
		self.golem = golem
		self.state = "Search"
		self.PointsOfInterest = []
		self.EverythingIHaveSeen = []
		self.GatheredItems = []
		self.FoundGarbage = []
		self.FoundDropOffs = []
		self.FocusItem = None
		
	def Frame(self):
		log("State= "+ self.state + "\nFocusItem= " + str(self.FocusItem))
		self.LookAroundMe()
		log("Now to do state logic")
		if self.state == "Search":
			self.ModeSearch()
		elif self.state == "PickUpItem":
			self.ModePickUpItem()
		elif self.state == "ReturnWithItem":
			log("now to do modeReturnwithitem")
			self.ModeReturnWithItem()
		else:
			pass		
	
	def LookAroundMe(self): 
		nearbyItems = self.golem.LookAround()		
		for x in nearbyItems:
			if x not in self.EverythingIHaveSeen:
				log("That looks new, what is it?")
				self.EverythingIHaveSeen.append(x)
				#Determine what the thing is, and what to do about it.
				if x.description.Contains("rotten") and x.description.Contains("item"):
					if x not in self.FoundGarbage:
						log("It's some garbage! Ill come back for it!")
						self.FoundGarbage.append(x)
				elif x.description.Contains("blue") and x.description.Contains("deposit"):
					if x not in self.FoundDropOffs:
						log("A garbage can, I can put trash there")
						self.FoundDropOffs.append(x)
				
	
	def ModeSearch(self):	
		if self.FocusItem == None:
			for	y in self.FoundGarbage:
				if y not in self.GatheredItems:						
					self.state = "PickUpItem"
					self.FocusItem = y
						
	
	def ModePickUpItem(self):	
		self.golem.GoToItem(self.FocusItem)			
		distance = self.golem.MyDistanceTo(self.FocusItem)		
		if self.golem.handsFull() == True:
			self.FocusItem = self.golem.heldItem()
			self.state = "ReturnWithItem"
		elif distance < 1:
			self.golem.PickUp(self.FocusItem)
	
	def ModeReturnWithItem(self):
		self.golem.GoToItem(self.FindClosestDropOff())	
		distance = self.golem.MyDistanceTo(self.FindClosestDropOff())
		if distance < 2:
			self.golem.PutDown()
			self.FindClosestDropOff().DepositItem(self.FocusItem)
			self.GatheredItems.append(self.FocusItem)
			self.FocusItem = None
			self.state = "Search"		
			
	def FindClosestDropOff(self):
		lowestDistance = 99999
		winner = None
		for SF in self.FoundDropOffs:
			distance = self.golem.MyDistanceTo(SF)
			if distance < lowestDistance:
				winner = SF
				lowestDistance = distance
		return winner