# Emily, this is the ancient script passed down for generations. 
# it will make the golem follow it's master if it has found them. 
# I tried to put some information in here for you, but my eyes are fading.
# use the hash sign to make the golem ignore runes, like this text.
# Don't be afraid of mistakes, they are the best teacher. I love you Emily.

class golem: 
	# This is where the golem starts. The golem is taken in and stored with the self
	# self.something is our personal fields of data
	def __init__(self, golem):
		self.golem = golem
		self.state = "Follow"
		# the [] means these are arrays or lists. They hold many things in one spot
		self.EverythingIHaveSeen = []
		self.GuysThatWeQuoteTookCareOf = []
		self.FoundEnemy = []
		self.FoundDropOffs = []
		self.FocusItem = None
		# This is you, emily
		self.Master = None
		
	def Frame(self):
		#log("State= "+ self.state + "\nFocusItem= " + str(self.FocusItem))
		self.LookAroundMe()		
		if self.state == "Search":
			self.ModeSearch()
		elif self.state == "Kill":
			self.ModeKill()
		elif self.state == "Follow":
			self.ModeFollowMaster()
		else:
			pass		
	
	# This function is called so that the golem may see what is around it.
	def LookAroundMe(self):
		nearbyItems = self.golem.LookAround()		# tc engine
		for x in nearbyItems:
			if x not in self.EverythingIHaveSeen:
				log("That looks new, what is it?")
				self.EverythingIHaveSeen.append(x)
				#Determine what the thing is, and what to do about it.
				if x.description.Contains("enemy") and x.description.Contains("danger"):
					if x not in self.FoundEnemy or x not in self.GuysThatWeQuoteTookCareOf:
						log("It's some garbage! Ill come back for it!")
						self.FoundEnemy.append(x)
				elif x.description.Contains("master") and self.Master is None:
					log("Hello World, Hello master!")
					self.Master = x
	
	def ModeSearch(self):	
		if self.FocusItem is None:
			for	y in self.FoundEnemy:
				if y not in self.GuysThatWeQuoteTookCareOf and not y.description.Contains("dead"):
					log("EXTERMINATE")
					self.state = "Kill"
					self.FocusItem = y
					break			
			if self.FocusItem is None:			
				self.state = "Follow"
							
	def ModeKill(self):	
		self.golem.GoToItem(self.FocusItem)			
		distance = self.golem.MyDistanceTo(self.FocusItem)		
		if distance < 1 and not self.FocusItem.description.Contains("dead"):
			self.golem.Attack()
		#Check to see if he is dead, so we can do something else
		if self.FocusItem.description.Contains("dead"):
			log("He is dead, lets find another :D")
			self.FoundEnemy.remove(self.FocusItem)
			self.GuysThatWeQuoteTookCareOf.append(self.FocusItem)
			self.FocusItem = None
			self.state = "Search"	

	def ModeFollowMaster(self):
		if self.Master is not None:
			distanceToMaster = self.golem.MyDistanceTo(self.Master)
			if distanceToMaster < 3:			
				self.golem.Halt()
			else:
				self.golem.GoToItem(self.Master)
		if len(self.FoundEnemy) > 0:
			self.state = "Search" 
# I wish I could help you more, but as I run out of time, I also run out of space.
# Be smarter than me Emily.
# Like writing new lines with very little information
# But don't be afraid to write these notes yourself, lest you forget 